// FUTURE: lots of web page knowledge (ids, h2, etc) assumed here. at least centralize it somehow
// FUTURE: is there a way to patch scripts from the server?
// TODO: rotating phone doesn't fix size right away
// FUTURE: tablet landscape mode looks like shit
// FUTURE: use backbone.js for all this model -> view updating
// TODO: ads
// FUTURE: handle back button from review dialog??


(function() {
	
var _elementIds = {
	splashScreenPage: '#splashScreenPage',
	feedPage: '#feedPage',
	articlePage: '#articlePage',
	schedulePage: '#schedulePage',
	morePage: '#morePage',
	reviewRequestPage: '#reviewRequestPage',
	
//	webView: '#webView',
	
//	scheduleGameIndex: '#scheduleGameIndex',
	
	templateFeed: "#feedTemplate",
	templateSchedule: '#scheduleTemplate',
	templateScheduleItem: '#scheduleItemTemplate',

	sentFeedbackLink: "#sentFeedbackLink"
};

var _cssClasses = {
	reviewApp: '.reviewApp',
	neverReviewApp: '.neverReviewApp',
	reviewAppLater: '.reviewAppLater',
	gameNotifyToggle: '.gameNotifyToggle'
};

Sports247.App.Debug = {};
Sports247.App.Debug.getElementIds = function() { return $.extend({}, _elementIds); };
Sports247.App.Debug.getCssClasses = function() { return $.extend({}, _cssClasses); };

Sports247.App.start = function(rootElement) {
	document.addEventListener("deviceready", function() {
		Sports247.App.startInternal(rootElement);
	}, false);
};

Sports247.App.startInternal = function(rootElement) {
	// Set current team
	// Find team=<teamName> and league=<league> params
	try {
		// FUTURE: repair this when it doesn't crash PhoneGap someday
		/*
		var teamName = /[?&]team=([^&#]+)/.exec(window.location.href);
		var leagueName = /[?&]league=([^&#]+)/.exec(window.location.href);
		if (teamName && teamName.length == 2) {
			teamName = teamName[1];
		}
		if (leagueName && leagueName.length == 2) {
			leagueName = leagueName[1];
		}*/
		var currentTeamDef = Sports247.Config.TeamConfig[Sports247.App.appLeague][Sports247.App.appTeam];
		Sports247.App.currentTeam(currentTeamDef);
	} catch (exc) {
		alert('Our apologies but an unexpected error occurred. Please try starting the app again');
		navigator.app.exitApp();
	}


	// Set stylesheet
	$('head').append('<link id="teamCss" rel="stylesheet" href="teamCss/' + Sports247.App.currentTeam().serverTeamName + '.css" />');

	// modify html dynamically
	$('.fillAppName').text('24-7 Sports');
	$('.fillTeamName').text(Sports247.App.currentTeam().teamName);
	$('.fillFullTeamName').text(Sports247.App.fullTeamName());
	$(_cssClasses.reviewApp).attr('href', "market://details?id=" + Sports247.App.currentTeam().packageId);
	$(_elementIds.sentFeedbackLink).attr('href', "mailto:info@sparetimeventures.com?subject=Feedback%20on%2024-7%20" + Sports247.App.currentTeam().teamName + "%20(Android)");



	// Show splash screen
	window.location.hash = '';
	Sports247.UI.changePage(_elementIds.splashScreenPage);

	// Validate app compat
	if (!localStorage) {
		alert('Unfortunately this application is not fully compatible with your device. Please let us know about this so we can fix it.');
		// FUTURE: some analytics here!
	}

	// Setup template helpers
	Handlebars.registerHelper('encodeURIComponent', function(uri) {
		return encodeURIComponent(uri);
	});
	var scheduleItemTemplate = $(_elementIds.templateScheduleItem).html();
	Handlebars.registerPartial('scheduleItemTemplate', scheduleItemTemplate);

	// Start loading the feed
	Sports247.Model.beginLoadFeed(
		Sports247.App.currentTeam().server,
		Sports247.App.currentTeam().serverTeamName,
		Sports247.Config.appVersion,
		Sports247.Config.deviceId,
		function(feedData) {
			Sports247.App.initialFeedLoaded(rootElement, feedData);
		});
};

Sports247.App.initialFeedLoaded = function(rootElement, feedData) {
	// Setup page change handlers
	$(document).bind("pagebeforechange", function(e, prevPage, newPage) {
		Sports247.App.beforeDynamicPageNav(e, prevPage, newPage, feedData);
	});
	$(document).bind("pageafterchange", function(e, newPage) {
		Sports247.App.afterDynamicPageNav(e, newPage, feedData);
	});
	$(document).bind("virtualpageactivation", function(e, hash) {
		Sports247.App.handleVirtualPageNav(e, hash);
	});
	
	// Setup Android hardware buttons
	// FUTURE: this is a testing problem
	$(document).bind("backbutton", Sports247.App.handleBackButton);
	$(document).bind("menubutton", Sports247.App.handleMenuButton);
	
	// Setup child browser plug-in
	if (window.plugins.childBrowser) {
		// FUTURE: this is a testing problem
		window.plugins.childBrowser.onClose = Sports247.App.handleChildBrowserClose;
	}

	// Setup dynamic UI
	Sports247.App.setupNotificationUI();

	if (feedData) {
		Sports247.UI.changePage(_elementIds.feedPage);

		// Check if user should review app
		Sports247.App.setupAppReviewRequest();
		
		Sports247.App.updateFeed(feedData);
		Sports247.Model.beginLoadSchedule(
			Sports247.App.currentTeam().server,
			Sports247.App.currentTeam().serverTeamName,
			Sports247.App.updateSchedule);
	} else {
	}
};

Sports247.App.beforeDynamicPageNav = function(e, prevPage, newPage, feedData) {
	// Then handle the new page
	if (window.location.hash.search(new RegExp("^" + _elementIds.articlePage)) === 0) {
		var articleIndex = parseInt(window.location.hash.replace(/.*article-index=/, ''));
		Sports247.App.updateArticle(feedData, articleIndex);
	} else if (window.location.hash.search(new RegExp("^" + _elementIds.reviewRequestPage)) === 0) {
		newPage.attr("prevPageId", prevPage.attr("id"));
	}
};

Sports247.App.afterDynamicPageNav = function(e, newPage, feedData) {
	// FUTURE: think about how this scroll-bar updating timing should work
	if (window.location.hash.search(new RegExp("^" + _elementIds.schedulePage)) === 0) {
		Sports247.App.ensureScheduleData();
		Sports247.App.scrollSchedule();
	} else if (window.location.hash.search(new RegExp("^" + _elementIds.feedPage)) === 0) {
		Sports247.App.ensureFeedData();
	} else if (window.location.hash.search(new RegExp("^" + _elementIds.articlePage)) === 0) {
		Sports247.App.updateArticleScroll();
	}
};

Sports247.App.handleVirtualPageNav = function(e, hash) {
	if (window.location.hash.search(new RegExp("^#webView")) === 0) {
		var urlEncoded = /[?&]url=([^?&]+)/.exec(window.location.hash);
		if (urlEncoded && urlEncoded.length == 2) {
			var url = decodeURIComponent(urlEncoded[1]);
			// FUTURE: this is bad for testing
			if (window.plugins.childBrowser) {
				window.plugins.childBrowser.showWebPage(url);
			} else {
				alert('Failed to navigate to ' + url);
			}
		}
	}
};

Sports247.App.handleChildBrowserClose = function() {
	Sports247.App.handleBackButton();
};

Sports247.App.handleBackButton = function() {
	// FUTURE: maybe something smarter here like a true history
	var activePageElement = Sports247.UI.activePage();
	var backButton = activePageElement.find('.back-button');
	if (backButton && backButton.length > 0) {
		window.location = backButton[0].href;
	} else if (activePageElement.attr("id") == "feedPage") {
		// FUTURE: maybe prompt the user before quitting
		navigator.app.exitApp();
	}
};

Sports247.App.handleMenuButton = function() {
	Sports247.UI.changePage(_elementIds.morePage);
};


/*
 * CURRENT TEAM
 */
(function() {
	_currentTeamDef = null;
	Sports247.App.currentTeam = function(teamDefinition) {
		if (teamDefinition) {
			_currentTeamDef = teamDefinition;
			$('teamCss').remove();
			$('head').append('<link id="teamCss" rel="stylesheet" href="teamCss/' + _currentTeamDef.serverTeamName + '.css" />');
		}
		return _currentTeamDef;
	};

	Sports247.App.fullTeamName = function() {
		return Sports247.App.currentTeam().city + " " + Sports247.App.currentTeam().teamName;
	};
})();


/*
 * FEED
 */
(function() {
	var _feedContentIscroll = null;
	
	Sports247.App.updateFeed = function(feedData) {
		var feedTemplateSrc = $(_elementIds.templateFeed).html();
		var feedTemplate = Handlebars.compile(feedTemplateSrc);
		var feedHtml = feedTemplate(feedData);
		
		$(_elementIds.feedPage).find('.content').html("");
		$(_elementIds.feedPage).find('.content').append(feedHtml);
		_feedContentIscroll = new iScroll('feedContentOuter', { hideScrollbar: true, fadeScrollbar: true});
	};

	Sports247.App.ensureFeedData = function() {
		// FUTURE: this should actually ensure the data is up-to-date
		if (_feedContentIscroll) {
			_feedContentIscroll.refresh();
		}
	};
})();


/*
 * ARTICLE
 */
(function() {
	var _articleContentIscroll = null;

	Sports247.App.updateArticle = function(feedData, articleIndex) {
		// FUTURE: make links in story work?
		var articleTemplateSrc = $('#articleTemplate').html();
		var articleTemplate = Handlebars.compile(articleTemplateSrc);
		var articleHtml = articleTemplate(feedData.feedItems[articleIndex]);
		$(_elementIds.articlePage).find('.content').html("");
		$(_elementIds.articlePage).find('.content').append(articleHtml);
	};

	Sports247.App.updateArticleScroll = function() {
		if (!_articleContentIscroll) {
			_articleContentIscroll = new iScroll('articleContentOuter', { hideScrollbar: true, fadeScrollbar: true});
		} else {
			_articleContentIscroll.refresh();
		}
		_articleContentIscroll.scrollTo(0, 0, 0);
	};
})();


/*
 * SCHEDULE
 */
(function() {
	var _scheduleData = null;
	var _scheduleContentIscroll = null;

	Sports247.App.updateSchedule = function(scheduleData) {
		_scheduleData = scheduleData;

		var scheduleTemplateSrc = $(_elementIds.templateSchedule).html();
		var scheduleTemplate = Handlebars.compile(scheduleTemplateSrc);
		var scheduleHtml = scheduleTemplate(scheduleData);

		$(_elementIds.schedulePage).find('.content').html("");
		$(_elementIds.schedulePage).find('.content').append(scheduleHtml);

		_scheduleContentIscroll = new iScroll('scheduleContentOuter', { hideScrollbar: true, fadeScrollbar: true});
		
		// Just in case the user is already viewing the schedule page,
		// reset the scroll position
		Sports247.App.scrollSchedule();

		// Update notifications in case schedule has changed
		Sports247.App.tryUpdatingNotifications();
	};

	Sports247.App.getScheduleData = function() {
		return _scheduleData;
	};
	
	Sports247.App.ensureScheduleData = function() {
		// FUTURE: this should actually ensure the data is up-to-date
		if (_scheduleData && _scheduleContentIscroll) {
			_scheduleContentIscroll.refresh();
		}
	};
	
	Sports247.App.scrollSchedule = function() {
		var scheduleData = Sports247.App.getScheduleData();
		if (scheduleData && _scheduleContentIscroll) {
			var hasPreviousGames = (scheduleData.previousGames.length > 0);
			var hasCurrentNextGames = (scheduleData.currentAndNextGames.length > 0);
			var firstVisibleGameIndex = -1;
			if (hasPreviousGames) {
				if (hasCurrentNextGames) {
					// view last previous game
					firstVisibleGameIndex = scheduleData.previousGames[scheduleData.previousGames.length - 1].gameIndex;
				} else {
					// scroll to end of list
					firstVisibleGameIndex = scheduleData.games.length - 1;
				}
			} else if (hasCurrentNextGames) {
				// scroll to very top
				firstVisibleGameIndex = -1;
			}
			
			if (firstVisibleGameIndex >= 0) {
				_scheduleContentIscroll.scrollToElement('#scheduleGameIndex' + firstVisibleGameIndex, 100);
			}
		}

		// FUTURE: put this somewhere else... maybe rename this function to general UI setup
		if (Sports247.App.getNotificationTime() <= 0) {
			// FUTURE: this CSS tag should work anywhere on the site, any time
			// an item is added but I don't know a good way to dynamically know
			// when a new element's been added with this css property
			$(_elementIds.schedulePage).find('.showOnlyIfNotificationsOff').show();
			$(_elementIds.schedulePage).find('.turnOnNotifications').click(
				function() {
					Sports247.App.turnOnNotifications();
				});
		} else {
			$(_elementIds.schedulePage).find('.showOnlyIfNotificationsOff').hide();
		}
	};

	Sports247.App.Debug.forceSchedule = function(scheduleData, fnUse) {
		var oldScheduleData = _scheduleData;
		try {
			_scheduleData = scheduleData;
			fnUse();
		} catch(err) {
			throw err;
		} finally {
			_scheduleData = oldScheduleData;
		}
	};

})();


/*
 * GAME NOTIFICATIONS
 */
(function() {
	var _notificationKeys = {
		minutesBeforeGameNotification: 'minutesBeforeGameNotification'
	};
	Sports247.App.Debug.getNotificationKeys = function() { return $.extend({}, _notificationKeys); };

	Sports247.App.tryUpdatingNotifications = function() {
		var scheduleData = Sports247.App.getScheduleData();
		if (!scheduleData) {
			return false;
		}

		if (!plugins.localNotification) {
			return false;
		}

		// Start from scratch
		plugins.localNotification.cancelAll();

		// Add notifications if necessary
		// FUTURE: we shouldn't add "current" games
		var minutesBeforeGame = Sports247.App.getNotificationTime();
		if (minutesBeforeGame > 0) {
			for (var i = 0; i < scheduleData.currentAndNextGames.length; i++) {
				var game = scheduleData.currentAndNextGames[i];
				plugins.localNotification.add({
					date : new Date(game.start.getTime()).add('m', -minutesBeforeGame),
					message : game.summary + "\r\n" + game.description,
					ticker : Sports247.App.fullTeamName() + " Game Time!",
					repeatDaily : false,
					id : i
					});
			}
		}

		return true;
	};

	function setNotificationTime(minutes) {
		localStorage[_notificationKeys.minutesBeforeGameNotification] = minutes;
		Sports247.App.tryUpdatingNotifications();
		$(_cssClasses.gameNotifyToggle).trigger('notificationChange', minutes);
		if (minutes > 0) {
			$(".showOnlyIfNotificationsOff").hide();
		} else {
			$(".showOnlyIfNotificationsOff").show();
		}
		return true;
	}

	Sports247.App.Debug.refreshNotificationTime = function() {
		setNotificationTime(Sports247.App.getNotificationTime());
	};


	Sports247.App.turnOnNotifications = function() {
		setNotificationTime(15);
	};

	Sports247.App.turnOffNotifications = function() {
		setNotificationTime(0);
	};

	Sports247.App.getNotificationTime = function() {
		var minutesBeforeGame = Sports247.Utilities.LocalStorage.getInt(_notificationKeys.minutesBeforeGameNotification);
		if (minutesBeforeGame && minutesBeforeGame > 0) {
			return minutesBeforeGame;
		}

		return 0;
	};

	Sports247.App.setupNotificationUI = function() {
		Sports247.UI.setupToggleButton(
			_cssClasses.gameNotifyToggle,
			[
				["Turn off Game Reminders", function() { Sports247.App.turnOffNotifications(); }],
				["Remind me of upcoming games!", function() { Sports247.App.turnOnNotifications(); }]
			],
			['notificationChange'],
			function() {
				var minutesBeforeGame = Sports247.App.getNotificationTime();
				return (minutesBeforeGame > 0) ? 0 : 1;
			});
	};
})();


/*
 * REVIEW REQUEST
 */
(function() {

	var _isReviewRequestPageSetup = false;
	var _runInfoKeys = {
		dateFirstRunKey: 'lastReviewCheckFirstRunDate',
		useCountKey: 'lastReviewCheckCount',
		dontCheckKey: 'lastReviewCheckStop',
		dateLastPromptKey: 'lastReviewCheckLastPromptDate'
	};
	Sports247.App.Debug.getRunInfoKeys = function() { return $.extend({}, _runInfoKeys); };


	var _daysBeforeRequestReview = 4;
	var _countBeforeRequestReview = 5;
	
	function checkLastReviewDate() {
		// FUTURE: what happens if there's no local storage?
		if (localStorage) {
			// FUTURE: Check for app upgrade (version change check)
			
			// Mark first run if not already
			if (!Sports247.Utilities.LocalStorage.getDate(_runInfoKeys.dateFirstRunKey)) {
				localStorage[_runInfoKeys.dateFirstRunKey] = new Date().clearTime();
			}
			
			// Update run count
			if (!Sports247.Utilities.LocalStorage.getInt(_runInfoKeys.useCountKey)) {
				localStorage[_runInfoKeys.useCountKey] = 0;
			}
			localStorage[_runInfoKeys.useCountKey]++;

			// Check our absolute stop setting
			if (Sports247.Utilities.LocalStorage.getBool(_runInfoKeys.dontCheckKey)) {
				return false;
			}
			
			// Should we prompt the user?
			if (Sports247.Utilities.LocalStorage.getInt(_runInfoKeys.useCountKey) >= _countBeforeRequestReview &&
				Sports247.Utilities.LocalStorage.getDate(_runInfoKeys.dateFirstRunKey).add('d', _daysBeforeRequestReview).getTime() <= new Date().clearTime().getTime()) {

					// We should, but let's see if we've already done it today
					if (!Sports247.Utilities.LocalStorage.getDate(_runInfoKeys.dateLastPromptKey) ||
						!Sports247.Utilities.LocalStorage.getDate(_runInfoKeys.dateLastPromptKey).equalsIgnoreTime(new Date())) {
							
						// We haven't done it today:
						// 1. Update the prompt date
						localStorage[_runInfoKeys.dateLastPromptKey] = new Date();
						
						// 2. Prompt the user
						return true;
					}
			}
		}

		return false;
	}
	
	function neverReviewApp() {
		localStorage[_runInfoKeys.dontCheckKey] = true;
	}
	
	Sports247.App.setupAppReviewRequest = function() {
		if (!_isReviewRequestPageSetup) {
			_isReviewRequestPageSetup = true;
			
			$(_cssClasses.reviewApp).click(neverReviewApp);
			$(_cssClasses.neverReviewApp).click(neverReviewApp);
			
			$(_elementIds.reviewRequestPage).find('.content a').click(function() {
				Sports247.UI.unlockCurrentPage();
				var prevPageId = $(_elementIds.reviewRequestPage).attr("prevPageId");
				Sports247.UI.changePage("#" + prevPageId);
			});
		}

		if (checkLastReviewDate()) {
			// FUTURE: this substr should be more generic
			if (Sports247.UI.activePage().attr("id") != _elementIds.reviewRequestPage.substr(1)) {
				Sports247.UI.changePage(_elementIds.reviewRequestPage);
				Sports247.UI.lockCurrentPage();
			}
			return true;
		}
		
		return false;
	};
})();

})();
