function debug_activateUI() {
	function resetLocalStorage() {
		for (var lsKey in localStorage) {
			localStorage.removeItem(lsKey);
		}
		updateLocalStorageOutput();
	}

	function askReviewNextBoot() {
		var runInfoKeys = Sports247.App.Debug.getRunInfoKeys();
		localStorage[runInfoKeys.dateFirstRunKey] = new Date().add('d', -5).clearTime();
		localStorage[runInfoKeys.useCountKey] = 10;
		updateLocalStorageOutput();
	}

	function getLocalStorageOutput() {
		var output = "";
		for (var lsKey in localStorage) {
			output += "<b>" + lsKey + ": </b>";
			output += localStorage[lsKey] + "<br/>";
		}
		return output;
	}

	function updateLocalStorageOutput() {
		$('#showLocalStorage').html(getLocalStorageOutput());
	}

	new iScroll('debugContentOuter', { hideScrollbar: true, fadeScrollbar: true});
	$('a#resetLocalStorage').click(resetLocalStorage);
	$('a#askReviewNextBoot').click(askReviewNextBoot);
	$('a#forceAppQuit').click(function() { navigator.app.exitApp(); });
	updateLocalStorageOutput();

	$(document).bind("menubutton", function() { Sports247.UI.changePage("#debugPage"); });

	var dbgButton = $('<input type="button" style="z-index:1000;position:fixed;top:0;left:0" value="debug">');
	dbgButton.click(function() {
		Sports247.UI.changePage("#debugPage");
		Sports247.UI.lockCurrentPage();
	});
	$('body').append(dbgButton);

	var nextTeamButton = $('<input type="button" style="z-index:1000;position:fixed;top:0;left:100px" value="nextTeam">');
	nextTeamButton.click(function() {
		var teamChanged = false;
		var foundTeam = false;
		while (true) {
			for (var leagueName in Sports247.Config.TeamConfig) {
				if (teamChanged) {
					break;
				}
				for (var teamName in Sports247.Config.TeamConfig[leagueName]) {
					var teamDesc = Sports247.Config.TeamConfig[leagueName][teamName];
					if (foundTeam) {
						$('.fillTeamName').text(teamDesc.serverTeamName);
						Sports247.App.currentTeam(teamDesc);
						teamChanged = true;
						break;
					} else if ($($('.fillTeamName')[0]).text() == teamDesc.serverTeamName) {
						foundTeam = true;
					}
				}
			}

			if (!foundTeam || teamChanged) {
				break;
			}
		}
	});
	$('body').append(nextTeamButton);
}
