function testModelOverride_addTestModelOverrides() {

Sports247.Utilities.Plist.beginLoadPlistData = function(url, successFn) {
	var testPlist = null;
	if (url.search(/feed/) >= 0) {
		testPlist = Sports247.Model.TestData.getFeedPlist();
	} else if (url.search(/cal/) >= 0) {
		testPlist = Sports247.Model.TestData.getSchedulePlist();
	}
	
	window.setTimeout(function() {
		var data = Sports247.Utilities.Plist.parsePlist(testPlist);
		successFn(data);
	},
	000);
};

Sports247.Model.TestData = {};

Sports247.Model.TestData.getFeedPlist = function() {
	with (Sports247.Utilities.Plist) {
		var feedItems = "";
		for (var i = 0; i < 100; i++) {
			var description =  '&lt;b&gt;h&lt;em&gt;e&lt;/em&gt;&lt;/b&gt;llo&lt;br/&gt;there&lt;script type="text/javascript"&gt;alert("OHNO!");&lt;/script&gt; and how are you doing? im doing fine, thanks! and yourself? just dandy! the rain in spain stays mainly in the plains. how now brown cow';
			for (var j = 0; j < 50; j++) {
				description += "<p>hello there, my name is bob.</p>";
			}
			feedItems +=
				getPlistDict(null,
					getPlistString('description', description) +
					getPlistString('title', i + ' - my title is my title and therefore its mine!') +
					getPlistString('link', 'http://www.news.com') +
					getPlistString('source', 'my news source'));

		}

		var plist = getPlistHeader();
		
		plist += getPlistDict(null,
					getPlistArray('feedItems', feedItems) +
					getPlistInteger('secondsToNextUpdate', 180)
				);

		plist += getPlistFooter();
		return plist;
	};
}

Sports247.Model.TestData.getSchedulePlist = function() {
	with (Sports247.Utilities.Plist) {
		var plist = getPlistHeader();

		plist += getPlistDict(null,
					getPlistArray('games',
						Sports247.Model.TestData.getScheduleItemPlist(-48) +
						Sports247.Model.TestData.getScheduleItemPlist(-36) +
						Sports247.Model.TestData.getScheduleItemPlist(-24) +
						Sports247.Model.TestData.getScheduleItemPlist(-12) +
						Sports247.Model.TestData.getScheduleItemPlist(-2) +
						Sports247.Model.TestData.getScheduleItemPlist(-1) +
						Sports247.Model.TestData.getScheduleItemPlist(0) +
						Sports247.Model.TestData.getScheduleItemPlist(1) +
						Sports247.Model.TestData.getScheduleItemPlist(2) +
						Sports247.Model.TestData.getScheduleItemPlist(12) +
						Sports247.Model.TestData.getScheduleItemPlist(24) +
						Sports247.Model.TestData.getScheduleItemPlist(36) +
						Sports247.Model.TestData.getScheduleItemPlist(48)
					)
				);

		plist += getPlistFooter();
	
		return plist;
	};
};

Sports247.Model.TestData.getScheduleItemPlist = function(timeOffset) {
	// Create date/times for game
	var startDate = new Date();
	startDate.add('h', timeOffset);
	var endDate = new Date();
	endDate.add('h', timeOffset).add('m', 10);
	
	// Adjust for timezone
	startDate.add('m', startDate.getTimezoneOffset());
	endDate.add('m', endDate.getTimezoneOffset());
	
	var dateFormat = "yyyyMMddTHHmmssZ";
	
	with (Sports247.Utilities.Plist) {
		var plist;
		plist = getPlistDict(null,
					getPlistString('description', 'L 3-24') +
					getPlistString('start', startDate.format(dateFormat)) +
					getPlistString('end', endDate.format(dateFormat)) +
					getPlistString('summary', 'San Francisco at New Orleans (' + timeOffset + ')'));
		return plist;
	}
}

}

